# CbcCutBranchingObject Class Reference

Cut branching object. More...

`#include <CbcBranchCut.hpp>`

Inheritance diagram for CbcCutBranchingObject:
[legend]
Collaboration diagram for CbcCutBranchingObject:
[legend]

List of all members.

## Public Member Functions
| CbcCutBranchingObject ()
| Default constructor.
| CbcCutBranchingObject (CbcModel *model, OsiRowCut &down, OsiRowCut &up, bool canFix)
| Create a cut branching object.
| CbcCutBranchingObject (const CbcCutBranchingObject &)
| Copy constructor.
CbcCutBranchingObject & | operator= (const CbcCutBranchingObject &rhs)
| Assignment operator.
virtual CbcBranchingObject * | clone () const
| Clone.
virtual | ~CbcCutBranchingObject ()
| Destructor.
virtual double | branch ()
| Sets the bounds for variables or adds a cut depending on the current arm of the branch and advances the object state to the next arm.
virtual void | print ()
| Print something about branch - only if log level high.
virtual bool | boundBranch () const
| Return true if branch should fix variables.
virtual CbcBranchObjType | type () const
| Return the type (an integer identifier) of `this`.
virtual int | compareOriginalObject (const CbcBranchingObject *brObj) const
| Compare the original object of `this` with the original object of `brObj`.
virtual CbcRangeCompare | compareBranchingObject (const CbcBranchingObject *brObj, const bool replaceIfOverlap=false)
| Compare the `this` with `brObj`.
## Protected Attributes
OsiRowCut | down_
| Cut for the down arm (way_ = -1).
OsiRowCut | up_
| Cut for the up arm (way_ = 1).
bool | canFix_
| True if one way can fix variables.

## Detailed Description

Cut branching object.

This object can specify a two-way branch in terms of two cuts

Definition at line 108 of file CbcBranchCut.hpp.

## Constructor & Destructor Documentation

CbcCutBranchingObject::CbcCutBranchingObject | ( |  | ) |

Default constructor.

CbcCutBranchingObject::CbcCutBranchingObject | ( | CbcModel * | model,
|  | OsiRowCut & | down,
|  | OsiRowCut & | up,
|  | bool | canFix |
| ) |  |  |

Create a cut branching object.

Cut down will applied on way=-1, up on way==1 Assumed down will be first so way_ set to -1

CbcCutBranchingObject::CbcCutBranchingObject | ( | const CbcCutBranchingObject & |  | ) |

Copy constructor.

virtual CbcCutBranchingObject::~CbcCutBranchingObject | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

CbcCutBranchingObject& CbcCutBranchingObject::operator= | ( | const CbcCutBranchingObject & | rhs | ) |

Assignment operator.

Reimplemented from CbcBranchingObject.

virtual CbcBranchingObject* CbcCutBranchingObject::clone | ( |  | ) | const`[virtual]`

Clone.

Implements CbcBranchingObject.

virtual double CbcCutBranchingObject::branch | ( |  | ) | `[virtual]`

Sets the bounds for variables or adds a cut depending on the current arm of the branch and advances the object state to the next arm.

Returns change in guessed objective on next branch

Implements CbcBranchingObject.

virtual void CbcCutBranchingObject::print | ( |  | ) | `[virtual]`

Print something about branch - only if log level high.

virtual bool CbcCutBranchingObject::boundBranch | ( |  | ) | const`[virtual]`

Return true if branch should fix variables.

Reimplemented from OsiBranchingObject.

virtual CbcBranchObjType CbcCutBranchingObject::type | ( |  | ) | const`[inline, virtual]`

Return the type (an integer identifier) of `this`.

Implements CbcBranchingObject.

Definition at line 151 of file CbcBranchCut.hpp.

virtual int CbcCutBranchingObject::compareOriginalObject | ( | const CbcBranchingObject * | brObj | ) | const`[virtual]`

Compare the original object of `this` with the original object of `brObj`.

Assumes that there is an ordering of the original objects. This method should be invoked only if `this` and brObj are of the same type. Return negative/0/positive depending on whether `this` is smaller/same/larger than the argument.

virtual CbcRangeCompare CbcCutBranchingObject::compareBranchingObject | ( | const CbcBranchingObject * | brObj,
|  | const bool | replaceIfOverlap = `false` |
| ) |  |  | `[virtual]`

Compare the `this` with `brObj`.

`this` and `brObj` must be os the same type and must have the same original object, but they may have different feasible regions. Return the appropriate CbcRangeCompare value (first argument being the sub/superset if that's the case). In case of overlap (and if `replaceIfOverlap` is true) replace the current branching object with one whose feasible region is the overlap.

## Member Data Documentation

OsiRowCut CbcCutBranchingObject::down_`[protected]`

Cut for the down arm (way_ = -1).

Definition at line 177 of file CbcBranchCut.hpp.

OsiRowCut CbcCutBranchingObject::up_`[protected]`

Cut for the up arm (way_ = 1).

Definition at line 179 of file CbcBranchCut.hpp.

bool CbcCutBranchingObject::canFix_`[protected]`

True if one way can fix variables.

Definition at line 181 of file CbcBranchCut.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Cbc-2.7.7/Cbc/src/CbcBranchCut.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines